Index: Singular/LIB/monomial.lib
===================================================================
--- Singular/LIB/monomial.lib	(revision 7f8587b3752e6d6a92df017bafdfb3d03198e66b)
+++ Singular/LIB/monomial.lib	(revision abbd22e3508e31d6abd926f194f4cb62f9365784)
@@ -2249,47 +2164,45 @@
   int count = 0;
   for (i = 1 ; i <= nvar ; i ++)
-    {
-      // Buscamos conflicto en la variable x(i), para ello tengo que ordenar
-      // la columna i de EXP
-      vari = EXP[1..sizI,i];
-      aux = sort(vari);
-      vari = aux[1];
-      change = aux[2];
-      for (j = 1 ; j <= sizI - 1 ; j ++)
-        {
-          if (vari[j] > 0)
-            {
-              while (NEWEXP[change[j + count] , i] >= vari[j + 1 + count])
-                {
-                  NEWEXP[change[j + 1 + count] , i] = NEWEXP[change[j + count] , i] + 1;
-                  count ++;
-                  if (j + 1 + count > sizI)
-                    {
-                      break;
-                    }
-                }
-            }
-          j = j + count;
-          count = 0;
-        }
-    }
-  setring R;
-  I = fetch(R1,I);
+  {
+    // Buscamos conflicto en la variable x(i), para ello tengo que ordenar
+    // la columna i de EXP
+    vari = EXP[1..sizI,i];
+    aux = sort(vari);
+    vari = aux[1];
+    change = aux[2];
+    for (j = 1 ; j <= sizI - 1 ; j ++)
+    {
+      if (vari[j] > 0)
+      {
+        while (NEWEXP[change[j + count] , i] >= vari[j + 1 + count])
+        {
+          NEWEXP[change[j + 1 + count] , i] = NEWEXP[change[j + count] , i] + 1;
+          count ++;
+          if (j + 1 + count > sizI)
+          {
+            break;
+          }
+        }
+      }
+      j = j + count;
+      count = 0;
+    }
+  }
   // Devolvemos tambien la matriz, pues aqui tengo la biyeccion entre los exponentes
   if (EXP == NEWEXP)
-    {
-      return (1,I);
-    }
+  {
+    return (1,I);
+  }
   else
-    {
-      // Hallamos el ideal con los nuevos exponentes
-      intvec expI;
-      for (i = 1 ; i <= sizI ; i ++)
-        {
-          expI = NEWEXP[i,1..nvar];
-          I[i] = monomial(expI);
-        }
-      return(0,I,EXP,NEWEXP);
-    }
+  {
+    // Hallamos el ideal con los nuevos exponentes
+    intvec expI;
+    for (i = 1 ; i <= sizI ; i ++)
+    {
+      expI = NEWEXP[i,1..nvar];
+      I[i] = monomial(expI);
+    }
+    return(0,I,EXP,NEWEXP);
+  }
 }
 //////////////////////////////////////////////////////////////////////
@@ -2301,6 +2214,5 @@
 static proc nonGeneric (EXP,NEWEXP,Faces,sizI)
 {
-  def R = basering;
-  int nvar = nvars(R);
+  int nvar = nvars(basering);
   int sizFaces = size(Faces);
   // Variables
@@ -2311,25 +2223,25 @@
   newFaces = Faces;
   for (i = 1 ; i <= nvar ; i ++)
-    {
-      // comparamos las matrices de exponentes por columnas
-      exp = EXP[1..sizI,i];
-      newexp = NEWEXP[1..sizI,i];
-      if (exp <> newexp)
-        {
-          for (j = 1 ; j <= sizI ; j ++)
+  {
+    // comparamos las matrices de exponentes por columnas
+    exp = EXP[1..sizI,i];
+    newexp = NEWEXP[1..sizI,i];
+    if (exp <> newexp)
+    {
+      for (j = 1 ; j <= sizI ; j ++)
+      {
+        if (exp[j] <> newexp[j])
+        {
+          for (k = 1 ; k <= sizFaces ; k ++)
+          {
+            if (Faces[k][i] == newexp[j])
             {
-              if (exp[j] <> newexp[j])
-                {
-                  for (k = 1 ; k <= sizFaces ; k ++)
-                    {
-                      if (Faces[k][i] == newexp[j])
-                        {
-                          newFaces[k][i] = exp[j];
-                        }
-                    }
-                }
+              newFaces[k][i] = exp[j];
             }
-        }
-    }
+          }
+        }
+      }
+    }
+  }
   return (newFaces);
 }
@@ -2344,18 +2256,13 @@
   // Cambiamos de anillo
   // Queremos usar x(1)..x(n) como variables.
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int nvar = nvars(basering);
   // Declaracion de variables.
   int i,sizJ,j,max,aux,sizK,l, elim;
   intvec v;
   list face;
-  // Traemos al nuevo anillo el ideal de entrada.
-  ideal I = fetch(R,I);
   // Hacemos una copia de I pues ahora modificaremos el sistema
   // de generadores.
   ideal J = I;
-  sizJ = size(J);
+  sizJ = ncols(J);
   // Para cada variable buscamos el maximo exponente, teniendo en
   // cuenta que un mismo generador no puede dar dos exponentes.
@@ -2363,73 +2270,70 @@
   intvec expIni;
   for (i = 1 ; i <= nvar ; i++)
-    {
-      max = 0;
+  {
+    max = 0;
+    for (j = 1 ; j <= sizJ ; j++)
+    {
+      aux = leadexp(J[j])[i];
+      if (aux > max)
+      {
+        max = aux;
+        elim = j;
+      }
+    }
+    // Guardamos el exponente
+    expIni[i] = max;
+    // Ahora tenemos el maximo de la variable x(i), por lo que
+    // eliminamos el generador en el que la encontramos.
+    // Si queda un generador no hay nada que hacer
+    if (sizJ <> 1)
+    {
+      if (elim <> 1 & elim <> sizJ)
+      {
+        J = J[1..elim-1],J[elim+1..sizJ];
+      }
+      else
+      {
+        if (elim == 1)
+        {
+          J = J[2..sizJ];
+        }
+        else
+        {
+          J = J[1..sizJ-1];
+        }
+      }
+      sizJ = ncols(J);
+      // Eliminamos la variable x(i) en todos los generadores.
       for (j = 1 ; j <= sizJ ; j++)
-        {
-          aux = leadexp(J[j])[i];
-          if (aux > max)
-            {
-              max = aux;
-              elim = j;
-            }
-        }
-      // Guardamos el exponente
-      expIni[i] = max;
-      // Ahora tenemos el maximo de la variable x(i), por lo que
-      // eliminamos el generador en el que la encontramos.
-      // Si queda un generador no hay nada que hacer
-      if (sizJ <> 1)
-        {
-          if (elim <> 1 & elim <> sizJ)
-            {
-              J = J[1..elim-1],J[elim+1..sizJ];
-            }
-          else
-            {
-              if (elim == 1)
-                {
-                  J = J[2..sizJ];
-                }
-              else
-                {
-                  J = J[1..sizJ-1];
-                }
-            }
-          sizJ = size(J);
-          // Eliminamos la variable x(i) en todos los generadores.
-          for (j = 1 ; j <= sizJ ; j++)
-            {
-              v = leadexp(J[j]);
-              if (v [i] <> 0)
-                {
-                  v[i] = 0;
-                  J[j] = monomial(v);
-                }
-            }
-          // Hallamos el sistema minimal de generadores que
-          // corresponde al ideal que nos ha quedado.
-          J = minbase(J);
-          sizJ = size(J);
-        }
-    }
+      {
+        v = leadexp(J[j]);
+        if (v [i] <> 0)
+        {
+          v[i] = 0;
+          J[j] = monomial(v);
+        }
+      }
+      // Hallamos el sistema minimal de generadores que
+      // corresponde al ideal que nos ha quedado.
+      J = minbase(J);
+      sizJ = ncols(J);
+    }
+  }
   // En expIni tenemos los exponentes de los monomios que dan la cara
   // inicial, ahora hay que buscar en el ideal original a que
   // generador se corresponde (el ideal es generico)
-  int sizI = size(I);
+  int sizI = ncols(I);
   for (i = 1 ; i <= nvar ; i ++)
-    {
-      for (j = 1 ; j <= sizI ; j ++)
-        {
-          if (expIni[i] == leadexp(I[j])[i])
-            {
-              face = insert(face, I[j]);
-              // Si lo encontramos buscamos el siguiente
-              break;
-            }
-        }
-    }
-  setring R;
-  list face = fetch (R1,face);
-  kill R1;
+  {
+    for (j = 1 ; j <= sizI ; j ++)
+    {
+      if (expIni[i] == leadexp(I[j])[i])
+      {
+        face = insert(face, I[j]);
+        // Si lo encontramos buscamos el siguiente
+        break;
+      }
+    }
+  }
   return (face);
 }
@@ -2443,8 +2347,5 @@
   // Cambiamos de anillo
   // Queremos usar x(1)..x(n) como variables.
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int nvar = nvars(basering);
   // Declaracion de variables.
   int i,j,cambio,sizI,k,min,m,generador,max;
@@ -2452,46 +2353,43 @@
   poly LCM,newLCM;
   intvec v,newv,expgen;
-  // Traemos al nuevo anillo las dos entradas.
-  list l1 = fetch(R,l1);
-  ideal I = fetch(R,I);
-  sizI = size(I);
+  sizI = ncols(I);
   // Hallamos el lcm de los elementos, e. d., la faceta del
   // complejo para luego comparar con los nuevos
   LCM = 1;
   for (i = 1 ; i <= nvar ; i++)
-    {
-      LCM = lcmMon(LCM,l1[i]);
-    }
+  {
+    LCM = lcmMon(LCM,l1[i]);
+  }
   v = leadexp(LCM);
   // Calculo los exponentes de los monomios de I
   for (i = 1 ; i <= sizI ; i++)
-    {
-      expI[i] = leadexp(I[i]);
-    }
+  {
+    expI[i] = leadexp(I[i]);
+  }
   // Hay que quitar cada elemento de la lista y comprobar si hay o no
   // cara adyacente al simplice que queda, y en caso de haberla, la
   // calculamos.
   for (i = 1 ; i <= nvar ; i++)
-    {
-      newl1 = delete(l1,i);
-      // Hallamos el lcm de los elementos que hay en la nueva lista.
-      newLCM = 1;
-      for (j = 1 ; j <= nvar - 1 ; j++)
-        {
-          newLCM = lcmMon(newLCM,newl1[j]);
-        }
-      // Ahora hay que detectar si alguna variable ha desaparecido
-      // en este LCM.
-      newv = leadexp(newLCM);
-      for (j = 1 ; j <= nvar ; j++)
-        {
-          if (newv[j] == 0)
-            {
-              l2[i] = 0;
-              break;
-            }
-        }
-      if (j == nvar+1)
-        {
+  {
+    newl1 = delete(l1,i);
+    // Hallamos el lcm de los elementos que hay en la nueva lista.
+    newLCM = 1;
+    for (j = 1 ; j <= nvar - 1 ; j++)
+    {
+      newLCM = lcmMon(newLCM,newl1[j]);
+    }
+    // Ahora hay que detectar si alguna variable ha desaparecido
+    // en este LCM.
+    newv = leadexp(newLCM);
+    for (j = 1 ; j <= nvar ; j++)
+    {
+      if (newv[j] == 0)
+      {
+        l2[i] = 0;
+        break;
+      }
+    }
+    if (j == nvar+1)
+    {
       // Si no ha habido ceros, queremos hallar la cara adyacente,
       // es decir, buscar un generador que introducido en l1 de una
@@ -2499,110 +2397,107 @@
       // Comparamos los lcm entre s?, para comprobar en que variable
       // contribu?a el monomio que hemos eliminado.
-          for (j = 1 ; j <= nvar ; j++)
+      for (j = 1 ; j <= nvar ; j++)
+      {
+        if (v[j] <> newv[j])
+        {
+          cambio = j;
+          // Una vez encontrado no hay mas
+          break;
+        }
+      }
+      // Hallamos los exponentes de los monomios que quedan
+      // para ver cual da el exponente en "newv"
+      for (j = 1 ; j <= nvar - 1 ; j++)
+      {
+        w[j] = leadexp(newl1[j]);
+      }
+      for (j = 1 ; j <= nvar ; j++)
+      {
+        for (k = 1 ; k <= nvar - 1 ; k++)
+        {
+          if (newv[cambio] == w[k][cambio])
+          {
+            cambio = k;
+            break;
+          }
+        }
+        // Si no termino el for con k es que hemos encontrado ya
+        // los que son iguales.
+        if (k <> nvar)
+        {
+          break;
+        }
+      }
+
+      // Donde contribuye antes, e.d., en "v"
+      for (j = 1 ; j <= nvar ; j++)
+      {
+        if (w[cambio][j] == v[j])
+        {
+          cambio = j;
+          break;
+        }
+      }
+      // Ahora ya buscamos entre los generadores el nuevo monomio.
+      // Ponemos de tope para encontrar el minimo el maximo de
+      // las variables en el ideal
+      max = 0;
+      for (m = 1 ; m <= sizI ; m ++)
+      {
+        if (expI[m][cambio] > max)
+        {
+          max = expI[m][cambio];
+        }
+      }
+      min = max;
+      for (j = 1 ; j <= sizI ; j++)
+      {
+        for (k = 1 ; k <= nvar ; k ++)
+        {
+          if (I[j] == l1[k])
+          {
+            break;
+          }
+        }
+        // El generador no esta en la lista, es de los que hay que
+        // comprobar
+        if (k == nvar +1)
+        {
+          for (m = 1 ; m <= nvar ; m++)
+          {
+            if (m <> cambio)
             {
-              if (v[j] <> newv[j])
-                {
-                  cambio = j;
-                  // Una vez encontrado no hay mas
-                  break;
-                }
+              if (expI[j][m] > newv[m])
+              {
+                break;
+              }
             }
-          // Hallamos los exponentes de los monomios que quedan
-          // para ver cual da el exponente en "newv"
-          for (j = 1 ; j <= nvar - 1 ; j++)
+            else
             {
-              w[j] = leadexp(newl1[j]);
+              if (expI[j][m] <= newv[m])
+              {
+                break;
+              }
             }
-          for (j = 1 ; j <= nvar ; j++)
+          }
+          // Si termina el bucle cumple las condiciones
+          // oportunas, solo hay que comparar con el
+          // otro que tengamos.
+          if (m == nvar + 1)
+          {
+            if (expI[j][cambio] <=  min)
             {
-              for (k = 1 ; k <= nvar - 1 ; k++)
-                {
-                  if (newv[cambio] == w[k][cambio])
-                  {
-                    cambio = k;
-                    break;
-                  }
-                }
-              // Si no termino el for con k es que hemos encontrado ya
-              // los que son iguales.
-              if (k <> nvar)
-                {
-                  break;
-                }
+              min = expI[j][cambio];
+              generador = j;
             }
-        
-          // Donde contribuye antes, e.d., en "v"
-          for (j = 1 ; j <= nvar ; j++)
-            {
-              if (w[cambio][j] == v[j])
-                {
-                  cambio = j;
-                  break;
-                }
-            }
-          // Ahora ya buscamos entre los generadores el nuevo monomio.
-          // Ponemos de tope para encontrar el minimo el maximo de
-          // las variables en el ideal
-          max = 0;
-          for (m = 1 ; m <= sizI ; m ++)
-            {
-              if (expI[m][cambio] > max)
-                {
-                  max = expI[m][cambio];
-                }
-            }
-          min = max;        
-          for (j = 1 ; j <= sizI ; j++)
-            {
-              for (k = 1 ; k <= nvar ; k ++)
-                {
-                  if (I[j] == l1[k])
-                    {
-                      break;
-                    }
-                }
-              // El generador no esta en la lista, es de los que hay que
-              // comprobar
-              if (k == nvar +1)
-                {
-                  for (m = 1 ; m <= nvar ; m++)
-                    {
-                      if (m <> cambio)
-                        {
-                          if (expI[j][m] > newv[m])
-                            {
-                              break;
-                            }
-                        }
-                      else
-                        {
-                          if (expI[j][m] <= newv[m])
-                            {
-                              break;
-                            }
-                        }
-                    }
-                  // Si termina el bucle cumple las condiciones
-                  // oportunas, solo hay que comparar con el
-                  // otro que tengamos.
-                  if (m == nvar + 1)
-                    {
-                      if (expI[j][cambio] <=  min)
-                        {
-                          min = expI[j][cambio];
-                          generador = j;
-                        }
-                    }
-                }
-            }
-          // En la lista ponemos en el lugar "i" el generador que
-          // hay que introducir cuando eliminamos el generador
-          // "i" de la lista de entrada.
-          l2[i] = I[generador];
-        }
-    }
-  setring R;
-  list l2 = fetch(R1,l2);
-  kill R1;
+          }
+        }
+      }
+      // En la lista ponemos en el lugar "i" el generador que
+      // hay que introducir cuando eliminamos el generador
+      // "i" de la lista de entrada.
+      l2[i] = I[generador];
+    }
+  }
   return(l2);
 }
@@ -2616,10 +2511,7 @@
   // Cambiamos de anillo
   // Queremos usar x(1)..x(n) como variables.
-  def R = basering;
-  int nvar = nvars(R);
+  int nvar = nvars(basering);
   // Sabemos que dp siempre es mejor para trabajar, auqque luego para
   // comparar I y genI vamos a cambiarlo al lexicografico.
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
   // Variables
   int i,j,k,sizl1,sizl,cont1,cont2;
@@ -2629,5 +2521,4 @@
   intvec v,w,betas;
   ideal J,genI,artgenI;
-  ideal I = fetch(R,I);
   // Comprobamos si el ideal es generico y artiniano, y, en caso de
   // no serlo, obtenemos una modificacion de este ideal que si
@@ -2635,20 +2526,20 @@
   list genericlist = generic(I);
   if (genericlist[1] == 0)
-    {
-      genI = genericlist[2];
-    }
+  {
+    genI = genericlist[2];
+  }
   else
-    {
-      genI = I;
-    }
+  {
+    genI = I;
+  }
   list artinianization = artinian (genI);
   if (artinianization[1] == 0)
-    {
-      artgenI = artinianization[2];
-    }
+  {
+    artgenI = artinianization[2];
+  }
   else
-    {
-      artgenI = genI;
-    }
+  {
+    artgenI = genI;
+  }
   // Una vez tenemos el ideal artiniano y generico, podemos hallar
   // el complejo de Scarf asociado al ideal modificado
@@ -2663,8 +2554,8 @@
   LCM = 1;
   for (i = 1 ; i <= nvar ; i++)
-    {
-      mon = initial[i];
-      LCM = lcmMon(LCM,mon);
-    }
+  {
+    mon = initial[i];
+    LCM = lcmMon(LCM,mon);
+  }
   v = leadexp(LCM);
   // Guardamos la primera faceta
@@ -2677,65 +2568,65 @@
   // Ahora hayamos las posibles caras maximales adyacentes
   while (sizl <> 0)
-    {
-      // Hallamos la lista de monomios que hay que introducir
-      // cuando eliminamos cada monomio.
-      auxl = adyacency(l[1],artgenI);
-      cont1 = 1;
-      cont2 = 0;
-      l1 = 0;
+  {
+    // Hallamos la lista de monomios que hay que introducir
+    // cuando eliminamos cada monomio.
+    auxl = adyacency(l[1],artgenI);
+    cont1 = 1;
+    cont2 = 0;
+    l1 = 0;
+    for (j = 1 ; j <= nvar ; j++)
+    {
+      if (auxl[j] <> 0)
+      {
+        l2 = delete(l[1],j);
+        l1[cont1] = insert(l2,auxl[j],cont1 + cont2 - 1);
+        cont1 ++;
+      }
+      else
+      {
+        cont2 ++;
+      }
+    }
+    // Hallamos los nuevos LCM
+    sizl1 = size(l1);
+    for (i = 1 ; i <= sizl1 ; i++)
+    {
+      newLCM[i] = 1;
       for (j = 1 ; j <= nvar ; j++)
       {
-        if (auxl[j] <> 0)
-          {
-            l2 = delete(l[1],j);
-            l1[cont1] = insert(l2,auxl[j],cont1 + cont2 - 1);
-            cont1 ++;
-          }
-        else
-          {
-            cont2 ++;
-          }
-      }
-      // Hallamos los nuevos LCM
-      sizl1 = size(l1);
-      for (i = 1 ; i <= sizl1 ; i++)
-        {
-          newLCM[i] = 1;
-         for (j = 1 ; j <= nvar ; j++)
-           {
-             newLCM[i] = lcmMon(newLCM[i],l1[i][j]);
-           }
-         expl1[i] = leadexp(newLCM[i]);
-        }
-      // Hallamos los LCM de las nuevas caras y eliminamos las que
-      // ya esten en la lista Faces
-      cont1 = 0;
-      cont2 = 0;
-      for (i = 1 ; i <= sizl1 ; i++)
-        {
-          for (j = 1 ; j <= sizfaces ; j++)
-            {
-              v = expl1[i];
-              w = Faces[j];
-              if (v == w)
-                {
-                  // Si ya esta el LCM en la lista, no queremos
-                  // seguir buscando
-                  break;
-                }
-            }
-          // Si no ha salido del bucle en "j" es que este LCM
-          // no esta en la lista de las caras, la introducimos
-          if (j == sizfaces + 1)
-            {
-              Faces = insert(Faces,expl1[i],sizfaces + cont1);
-              l = insert(l,l1[i]);
-              cont1 ++;
-            }
-        }
-      l = delete(l,cont1 + 1);
-      sizl = size(l);
-      sizfaces = size(Faces);
-    }
+        newLCM[i] = lcmMon(newLCM[i],l1[i][j]);
+      }
+      expl1[i] = leadexp(newLCM[i]);
+    }
+    // Hallamos los LCM de las nuevas caras y eliminamos las que
+    // ya esten en la lista Faces
+    cont1 = 0;
+    cont2 = 0;
+    for (i = 1 ; i <= sizl1 ; i++)
+    {
+      for (j = 1 ; j <= sizfaces ; j++)
+      {
+        v = expl1[i];
+        w = Faces[j];
+        if (v == w)
+        {
+          // Si ya esta el LCM en la lista, no queremos
+          // seguir buscando
+          break;
+        }
+      }
+      // Si no ha salido del bucle en "j" es que este LCM
+      // no esta en la lista de las caras, la introducimos
+      if (j == sizfaces + 1)
+      {
+        Faces = insert(Faces,expl1[i],sizfaces + cont1);
+        l = insert(l,l1[i]);
+        cont1 ++;
+      }
+    }
+    l = delete(l,cont1 + 1);
+    sizl = size(l);
+    sizfaces = size(Faces);
+  }
   // En "Faces" ya tengo los exponentes que luego seran los exponentes
   // de los ideales que forman la descomposicion.
@@ -2743,53 +2634,50 @@
   intvec elimin = artinianization[3];
   if (artinianization[1] == 0)
-   {
-     // En elimina tenemos las variables que hemos introducido
-     // y cual es la potencia
-     // Solo miro las que tengan cambio
-     for (i = 1 ; i <= nvar ; i ++)
-       {
-         if (elimin[i] <> 0)
-           {
-             for (j = 1 ; j <= sizfaces ; j ++)
-               {
-                 if (Faces[j][i] == elimin[i])
-                   {
-                     Faces[j][i] = 0;
-                   }
-               }
-           }
-       }
-   }
+  {
+    // En elimina tenemos las variables que hemos introducido
+    // y cual es la potencia
+    // Solo miro las que tengan cambio
+    for (i = 1 ; i <= nvar ; i ++)
+    {
+      if (elimin[i] <> 0)
+      {
+        for (j = 1 ; j <= sizfaces ; j ++)
+        {
+          if (Faces[j][i] == elimin[i])
+          {
+            Faces[j][i] = 0;
+          }
+        }
+      }
+    }
+  }
   // Generico
   sizI = size(I);
   if (genericlist[1] == 0)
-    {
-      Faces = nonGeneric(genericlist[3],genericlist[4],Faces,sizI);
-    }
+  {
+    Faces = nonGeneric(genericlist[3],genericlist[4],Faces,sizI);
+  }
   // Ya tenemos en Faces los exponentes de las componentes
   // ahora solo hay que obtener los ideales.
- for (i = 1 ; i <= sizfaces ; i ++)
-    {
-      J = 0;
-      for (j = 1 ; j <= nvar ; j ++)
-        {
-          if (Faces[i][j] <> 0)
-            {
-              J = J,x(j)^(Faces[i][j]);
-            }
-        }
-      J = simplify(J,2);
-      Faces[i] = J;
-    }
- // Esta es la parte LENTA computacionalmente si el ideal de partida
- // no es generico
- if (genericlist[1] == 0)
-   {
-     Faces = irredundant(Faces);
-   }
- setring R;
- list components = fetch(R1,Faces);
- kill R1;
- return(components);
+  for (i = 1 ; i <= sizfaces ; i ++)
+  {
+    J = 0;
+    for (j = 1 ; j <= nvar ; j ++)
+    {
+      if (Faces[i][j] <> 0)
+      {
+        J = J,var(j)^(Faces[i][j]);
+      }
+    }
+    J = simplify(J,2);
+    Faces[i] = J;
+  }
+  // Esta es la parte LENTA computacionalmente si el ideal de partida
+  // no es generico
+  if (genericlist[1] == 0)
+  {
+    Faces = irredundant(Faces);
+  }
+  return(Faces);
 }
 //////////////////////////////////////////////////////////////////////
@@ -2821,8 +2709,5 @@
 {
   // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int nvar = nvars(basering);
   // Variables
   int sizF,i,j;
@@ -2830,5 +2715,4 @@
   list listphi;
   intvec exp,newexp;
-  list F = fetch(R,F);
   // F es una lista de pares, que indica una x(i) etiqueta de una
   // cara del ideal. Suponemos que F tiene ordenados sus elementos
@@ -2836,21 +2720,18 @@
   sizF = size(F);
   for (i = 1 ; i <= sizF ; i ++)
-    {
-      f = F[i];
-      exp = leadexp(f);
-      for (j = 1 ; j <= nvar ; j ++)
-        {
-          if (j <> i)
-            {
-              exp[j] = exp[j] + 1;
-            }
-        }
-      listphi[i] = monomial(exp);
-    }
+  {
+    f = F[i];
+    exp = leadexp(f);
+    for (j = 1 ; j <= nvar ; j ++)
+    {
+      if (j <> i)
+      {
+        exp[j] = exp[j] + 1;
+      }
+    }
+    listphi[i] = monomial(exp);
+  }
   // Ya tenemos la lista de los monomios a los que
   // luego haremos el "lcm"
-  setring R;
-  list listphi = fetch (R1,listphi);
-  kill R1;
   return (listphi);
 }
@@ -2860,23 +2741,16 @@
 {
  // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int nvar = nvars(basering);
   int i,sizI;
   intvec exp;
-  poly f = fetch (R,f);
   exp = leadexp(f);
-  for (i = 1 ; i <= nvar  ; i ++)
-    {
-      if (exp[i] <> 0)
-        {
-          exp[i] = exp[i] - 1;
-        }
-    }
+  for (i = nvar ; i > 0  ; i --)
+  {
+    if (exp[i] <> 0)
+    {
+      exp[i] = exp[i] - 1;
+    }
+  }
   f = monomial(exp);
-  setring R;
-  f = fetch (R1,f);
-  kill R1;
   return (f);
 }
@@ -2885,6 +2759,5 @@
 static proc conditionComplex (intvec posActual,ideal I,ideal S)
 {
-  def R = basering;
-  int nvar = nvars(R);
+  int nvar = nvars(basering);
   // VARIABLES
   int i,nuevo;
@@ -2893,49 +2766,49 @@
   // ultimo dentro de posActual que es distinto de 0.
   for (i = 1 ; i <= nvar ; i ++)
-    {
-      if (posActual[i] == 0)
-        {
-          break ;
-        }
-    }
+  {
+    if (posActual[i] == 0)
+    {
+      break;
+    }
+  }
   nuevo = i - 1;
   // No se pueden repetir generadores, se mira que el ultimo que se ha
- // ha introducido no sea de los que ya tenemos
+  // ha introducido no sea de los que ya tenemos
   for (i = 1 ; i <= nuevo - 1 ; i ++)
-    {
-      if (posActual[i] == posActual[nuevo])
-        {
-          return (0);
-        }
-    }
+  {
+    if (posActual[i] == posActual[nuevo])
+    {
+      return (0);
+    }
+  }
   // Vemos si la variable oportuna divide al generador
   if (leadexp(I[i]) == 0)
-    {
-      return (0);
-    }
+  {
+    return (0);
+  }
   // Caso de que el LCM sea multiplo de los que ya tenemos
   poly LCM = 1;
   for (i = 1 ; i <= nuevo ; i ++)
-    {
-      F = insert (F,I[posActual[i]],size(F));
-    }
+  {
+    F = insert (F,I[posActual[i]],size(F));
+  }
   list phiF = phi(F);
   for (i = 1 ; i <= nuevo ; i ++)
-    {
-      LCM = lcmMon(phiF[i],LCM);
-    }
+  {
+    LCM = lcmMon(phiF[i],LCM);
+  }
   // Comprobamos si ya tenemos algun divisor del actual
   if (membershipMon(LCM,S) == 1)
-    {
-      return (0);
-    }
+  {
+    return (0);
+  }
   // Ahora vemos si la lista esta en el complejo simplicial
   if (membershipMon(LCM,I) == 1)
-    {
-      if (membershipMon(pi(LCM),I) == 0)
-        {
-          return (1,LCM);
-        }
-    }
+  {
+    if (membershipMon(pi(LCM),I) == 0)
+    {
+      return (1,LCM);
+    }
+  }
   return (0);
 }
@@ -2944,6 +2817,5 @@
 static proc findFaces (ideal I)
 {
-  def R = basering;
-  int nvar = nvars(R);
+  int nvar = nvars(basering);
   // Variables
   int i;
@@ -2956,40 +2828,40 @@
 
   int variable = 1;
-  int sizI = size(I);
+  int sizI = ncols(I);
   while (1)
-    {
-      while (posActual[variable] == sizI)
-        {
-          posActual[variable] = 0;
-          variable --;
-          if (variable == 0)
-            {
-              break;
-            }
-        }
-      // Comprobamos si hemos recorrido todas las posibilidades. Si
-      // es as?, terminamos el while
+  {
+    while (posActual[variable] == sizI)
+    {
+      posActual[variable] = 0;
+      variable --;
       if (variable == 0)
-        {
-          break;
-        }
-      posActual[variable] = posActual[variable] + 1;
-      // Comprobamos las condiciones para saber si los generadores que
-      // tenemos est?n o no en el complejo.
-      condiciones = conditionComplex (posActual,I,S);
+      {
+        break;
+      }
+    }
+    // Comprobamos si hemos recorrido todas las posibilidades. Si
+    // es as?, terminamos el while
+    if (variable == 0)
+    {
+      break;
+    }
+    posActual[variable] = posActual[variable] + 1;
+    // Comprobamos las condiciones para saber si los generadores que
+    // tenemos est?n o no en el complejo.
+    condiciones = conditionComplex (posActual,I,S);
 
-      if (condiciones[1] == 1 )
-        {
-          if (posActual[nvar] <> 0)
-            {
-              S = S,condiciones[2];
-              F = insert (F,condiciones[2]);
-            }
-          if (variable < nvar)
-            {
-              variable ++;
-            }
-        }
-    }
+    if (condiciones[1] == 1 )
+    {
+      if (posActual[nvar] <> 0)
+      {
+        S = S,condiciones[2];
+        F = insert (F,condiciones[2]);
+      }
+      if (variable < nvar)
+      {
+        variable ++;
+      }
+    }
+  }
   return (F);
 }
@@ -3002,9 +2874,5 @@
 static proc labelAlgorithm(ideal I)
 {
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
-  ideal I = fetch(R,I);
+  int nvar = nvars(basering);
 
   // Variables
@@ -3016,12 +2884,12 @@
   list artiniano = artinian (I);
   if (artiniano[1] == 0)
-    {
-      artI = artiniano[2];
-      intvec elimina = artiniano[3];
-    }
+  {
+    artI = artiniano[2];
+    intvec elimina = artiniano[3];
+  }
   else
-    {
-      artI = I;
-    }
+  {
+    artI = I;
+  }
   // Llamamos a findFaces para que encuentre las caras maximales del
   // complejo asociado al ideal
@@ -3031,28 +2899,28 @@
   poly f;
   for (i = 1 ; i <= sizComponents ; i ++)
-    {
-      f = components[i];
-      expComponents[i] = leadexp(f);
-    }
+  {
+    f = components[i];
+    expComponents[i] = leadexp(f);
+  }
   // Deshacemos la artinianizacion
   if (artiniano[1] == 0)
-   {
-     // En elimina tenemos las variables que hemos introducido
-     // y cual es la potencia
-     // Solo miro las que tengan cambio
-     for (i = 1 ; i <= nvar ; i ++)
-       {
-         if (elimina[i] <> 0)
-           {
-             for (j = 1 ; j <= sizComponents ; j ++)
-               {
-                 if (expComponents[j][i] == elimina[i])
-                   {
-                     expComponents[j][i] = 0;
-                   }
-               }
-           }
-       }
-   }
+  {
+    // En elimina tenemos las variables que hemos introducido
+    // y cual es la potencia
+    // Solo miro las que tengan cambio
+    for (i = 1 ; i <= nvar ; i ++)
+    {
+      if (elimina[i] <> 0)
+      {
+        for (j = 1 ; j <= sizComponents ; j ++)
+        {
+          if (expComponents[j][i] == elimina[i])
+          {
+            expComponents[j][i] = 0;
+          }
+        }
+      }
+    }
+  }
   // En exp(i) tengo los exponentes de cada variable de las que aparecen
   // en cada ideal.
@@ -3060,19 +2928,16 @@
   list facets;
   for (i = 1 ; i <= sizComponents ; i ++)
-    {
-      J = 0;
-      for (j = 1 ; j <= nvar ; j ++)
-        {
-          if (expComponents[i][j] <> 0)
-            {
-              J = J,x(j)^expComponents[i][j];
-            }
-        }
-      J = simplify(J,2);
-      facets[i] = J;
-    }
-  setring R;
-  list facets = fetch (R1,facets);
-  kill R1;
+  {
+    J = 0;
+    for (j = 1 ; j <= nvar ; j ++)
+    {
+      if (expComponents[i][j] <> 0)
+      {
+        J = J,var(j)^expComponents[i][j];
+      }
+    }
+    J = simplify(J,2);
+    facets[i] = J;
+  }
   return (facets);
 }
